//
//  igViewController.m
//  StackedDynamic_ObjC
//
//  Created by Torrey Betts on 11/12/13.
//  Copyright (c) 2013 Infragistics. All rights reserved.
//

#import <IGChart/IGChart.h>
#import "igViewController.h"
#import "DynamicStackedDataSource.h"

@implementation DataModel

- (id)init
{
    self = [super init];
    if (self)
    {
        _points = [[NSMutableArray alloc] init];
    }

    return self;
}

@end

@interface igViewController ()
{
    IGChartView *_chartView;
    DynamicStackedDataSource *_dataSource;
    NSMutableArray *_data;
}
@end

@implementation igViewController

- (void)viewDidLoad
{
    [super viewDidLoad];

    _data = [[NSMutableArray alloc] init];
    [self createData];

    _dataSource = [[DynamicStackedDataSource alloc] initWithData:_data labelPath:@"name" valuesPath:@"points"];

    _chartView = [[IGChartView alloc] initWithFrame:self.view.bounds];
    _chartView.autoresizingMask = UIViewAutoresizingFlexibleHeight|UIViewAutoresizingFlexibleWidth;
    _chartView.backgroundColor = [UIColor whiteColor];
    _chartView.theme = [IGChartDefaultThemes IGTheme];
    [_chartView addStackedSeriesForType:[IGStacked100ColumnSeries class] usingKey:@"series" withDataSource:_dataSource firstAxisKey:@"xAxis" secondAxisKey:@"yAxis"];
    [self.view addSubview:_chartView];
}

- (void)createData
{
    NSInteger totalPoints = arc4random_uniform(5) + 2;
    NSInteger totalFragments = arc4random_uniform(5) + 2;

    for (int i = 0; i < totalFragments; i++)
    {
        DataModel *dataModel = [[DataModel alloc] init];
        dataModel.name = [NSString stringWithFormat:@"Fragment %d", i];
        dataModel.title = [NSString stringWithFormat:@"Title %d", i];

        for (int j = 0; j < totalPoints; j++)
        {
            [dataModel.points addObject:[NSNumber numberWithInt:arc4random_uniform(100)]];
        }

        [_data addObject:dataModel];
    }
}

- (BOOL)prefersStatusBarHidden
{
    return YES;
}

@end